package u8c.ui.mmpac.action;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.JSplitPane;

import nc.ui.pub.beans.UIPanel;
import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UISplitPane;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pub.bill.BillData;
import nc.ui.pub.bill.BillEditEvent;
import nc.ui.pub.bill.BillEditListener;
import nc.ui.pub.bill.BillItem;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.GeneralBillHeaderVO;
import nc.vo.ic.pub.bill.GeneralBillItemVO;
import nc.vo.ic.pub.bill.GeneralBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.itf.mmpac.mmpac.IOrderTotalInfo;
import u8c.pubitf.ic.out.IMaterialOutMaintainAPI;
import u8c.ui.mmpac.datamodel.OrderDataModel;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;


@SuppressWarnings("deprecation")
public class ToMaterialOutDialog extends UIDialog implements ActionListener,BillEditListener{
	/**
	 * 弹框勾选推单生成下游单据-材料出
	 */
	private static final long serialVersionUID = -2605551888165671265L;
	private UISplitPane mainpanel = null;//主面板
	private BillCardPanel jlcardPanel = null;//卡面面板
	private UIPanel jlbtnpanel = null;//存放按钮的panel
	private UIButton saveCardBtn = null ; //保存
	private UIButton cancelBtn = null ; //取消
	private ClientEnvironment ce = ClientEnvironment.getInstance();
	private HRAggVO aggvo;
	IMaterialOutMaintainAPI imaterapi=(IMaterialOutMaintainAPI) NCLocator.getInstance().lookup(IMaterialOutMaintainAPI.class.getName());
	IOrderTotalInfo iorder = NCLocator.getInstance().lookup(IOrderTotalInfo.class);
	
	public ToMaterialOutDialog(HRAggVO aggvo) {
		super();
		initialize(aggvo);
		
	}
	
	
	public void initialize(HRAggVO aggvo){
		Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
		setName("clc");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setTitle("生产总订单-领料");
		setSize(1000,360);
		this.setResizable(true);
		setLocation((dimension.width-550)/2, (dimension.height-300)/2);
		setContentPane(getMainPanel());
		addListenerEvent();
		this.aggvo = aggvo;
		//展示数据
		OrderIssueVO[] issueArrays = getIssueVOs(aggvo);
		getJlcardPanel().getBillModel().setBodyDataVO(issueArrays);
		
		
	}


	//根据传入的aggvo获取issuevo数组
	private OrderIssueVO[] getIssueVOs(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		List<OrderIssueVO> issuevos = new ArrayList();
		for(CircularlyAccessibleValueObject vo : vos) {
			if(vo instanceof OrderIssueVO) {
				//本次执行数量不填就默认
				//执行完的表体在生单界面不展示
				OrderIssueVO issuevo = (OrderIssueVO) vo;
				UFDouble num = issuevo.getNum() == null ? new UFDouble(0) : issuevo.getNum();
				UFDouble execnum = issuevo.getExecnum() == null ? new UFDouble(0) : issuevo.getExecnum();
				if(num.equals(execnum) && num.equals(new UFDouble(0))) {
					continue;
				}
				issuevo.setBdef2(num.sub(execnum).toString());
				issuevos.add(issuevo);
			}
		}
		Object[] objArrays = issuevos.toArray();
		OrderIssueVO[] issueArrays = new OrderIssueVO[objArrays.length];
		for(int i = 0;i < objArrays.length;i++) {
			issueArrays[i] = (OrderIssueVO) objArrays[i];
		}
		return issueArrays;
	}
	
	
	private void addListenerEvent() {
		getSaveCardBtn().addActionListener(this);
		getCancelBtn().addActionListener(this);
		getJlcardPanel().addEditListener(this);
	}
	
	public UISplitPane getMainPanel(){
		if(mainpanel==null){
			mainpanel = new UISplitPane();
			mainpanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
			mainpanel.setTopComponent(getJlcardPanel());
			mainpanel.setBottomComponent(getJlbtnpanel());
			mainpanel.setDividerLocation(280);//分割位置
			mainpanel.setOneTouchExpandable(true);
			mainpanel.setDividerSize(8);
		}
		
		return mainpanel;
	}
	
	
	public UIPanel getJlbtnpanel() {
		if(jlbtnpanel==null){
			jlbtnpanel = new UIPanel();
			jlbtnpanel.setName("jlbtnpanel");
			jlbtnpanel.add(getSaveCardBtn());
			jlbtnpanel.add(getCancelBtn());
		}
		return jlbtnpanel;
	}
	
	public UIButton getSaveCardBtn() {
		
		if(saveCardBtn == null){
			saveCardBtn = new UIButton();
			saveCardBtn.setBounds(530,210, 20, 20);
			saveCardBtn.setName("saveCardBtn");
			saveCardBtn.setText("确定");
		}
		return saveCardBtn;
	}
	
	public UIButton getCancelBtn() {
		if(cancelBtn == null){
			cancelBtn = new UIButton();
			cancelBtn.setBounds(530,210, 75, 20);
			cancelBtn.setName("cancelBtn");
			cancelBtn.setText("取消");
		}
		return cancelBtn;
	}
	
	
	private BillCardPanel getJlcardPanel() {
		if(jlcardPanel==null){
			jlcardPanel=new BillCardPanel();
			jlcardPanel.setName("jlcardPanel");
			//根据单据模板编码加载模板
			jlcardPanel.loadTemplet("QS411",null,ce.getUser().getPrimaryKey(),ce.getCorporation().getPrimaryKey());
		}
		
		return jlcardPanel;
	}
	
	
	@Override
	public void afterEdit(BillEditEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void bodyRowChange(BillEditEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@SuppressWarnings("unchecked")
	@Override
	/**
	 * 按钮确定和取消执行方法
	 */
	public void actionPerformed(ActionEvent e) {
		//保存按钮
		if(e.getSource() == getSaveCardBtn()){
//			MessageDialog.showHintDlg(null, "测试", "开始");
			Vector<Vector<Object>> vectors= getJlcardPanel().getBillModel().getDataVector();
			StringBuffer errmsg = new StringBuffer();
			//数量校验
			try {
				int execsize = 0;//勾选的条数
				for(int i = 0; i < vectors.size(); i++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(i);
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						if(vector.get(1) == null) {
							errmsg.append("第"+(i+1)+"行本次执行数量为空！");
							continue;
						}
						execsize = execsize + 1;
						UFDouble execnum = new UFDouble(vector.get(1).toString());//本次执行数量
						UFDouble nnum = new UFDouble(vector.get(21).toString());//主数量
						UFDouble usednum = vector.get(29) == null?new UFDouble(0):new UFDouble(vector.get(29).toString());//已执行主数量
						if(execnum.compareTo(nnum.sub(usednum)) > 0) {
							errmsg.append("第"+(i+1)+"行本次执行数量超过订单剩余数量！");
						}
					}
				}
				
				if(!errmsg.toString().equals("")) {
					MessageDialog.showErrorDlg(mainpanel, "错误", errmsg.toString());
					return;
				}
				if(execsize == 0) {
					MessageDialog.showHintDlg(mainpanel, "提示", "请勾选要生成材料出库的数据");
					return;
				}
				OrderMainVO headvo = (OrderMainVO) this.aggvo.getParentVO();
				String pk_corp = headvo.getPk_corp();
				UFDate dbilldate = headvo.getDbilldate();
				String pk_order = headvo.getPk_order();
				GeneralBillVO[] aggvos = new GeneralBillVO[1];
				GeneralBillVO aggvo = new GeneralBillVO();
				GeneralBillHeaderVO icheadvo = new GeneralBillHeaderVO();
				icheadvo.setPk_corp(pk_corp);
				icheadvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
				icheadvo.setDbilldate(dbilldate);
				icheadvo.setCoperatorid(PubEnv.getPk_user());
				icheadvo.setCwarehouseid("1001V5100000000003GB");//仓库必填
				icheadvo.setBoutretflag(UFBoolean.FALSE);//是否退回 
				icheadvo.setBsalecooppur(UFBoolean.FALSE); // 销售出是否已协同生成采购入 
				icheadvo.setVnote("来源生产总订单");//备注
				icheadvo.setCbilltypecode("4D");
				aggvo.setParentVO(icheadvo);
				GeneralBillItemVO[] itemvos = new GeneralBillItemVO[execsize];
				Map<String, UFDouble> updatemap = new HashMap<>();
				
				int k = 0;
				for(int j = 0; j < vectors.size(); j++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(j);
					//自定义项20 为勾选按钮 ：勾选为Y 没有勾选是null
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						GeneralBillItemVO itemvo = new GeneralBillItemVO();
						String cmaterialcode = vector.get(7).toString();
						String pk_invbasdoc = "";//存货pk
						if(cmaterialcode.startsWith("0001")) {
							pk_invbasdoc = cmaterialcode;
						}
						else {
							InvbasdocVO invbasvo  = GetBaseDAOUtil.getInvVO(cmaterialcode);
							pk_invbasdoc = invbasvo.getPrimaryKey();
						}
						String prjcode = vector.get(2).toString();
						String cprojectid = "";
						if(prjcode.startsWith("1001")) {
							cprojectid = prjcode;
						}
						else {
							cprojectid = GetBaseDAOUtil.getprojectid(prjcode);
						}
						InvmandocVO invmanvo = GetBaseDAOUtil.getInvmanVO(pk_invbasdoc);
						String pk_invmandoc = invmanvo.getPrimaryKey();
						itemvo.setBbarcodeclose(UFBoolean.FALSE);
						itemvo.setBreturnprofit(UFBoolean.FALSE);
						itemvo.setBsafeprice(UFBoolean.FALSE);
						itemvo.setBsourcelargess(UFBoolean.FALSE);
						itemvo.setBtou8rm(UFBoolean.FALSE);
						itemvo.setBtransasset(UFBoolean.FALSE);
						itemvo.setBzgflag(UFBoolean.FALSE);
						itemvo.setCbodybilltypecode("4D");
						itemvo.setCbodywarehouseid("1001V5100000000003GB");
						itemvo.setCfirstbillhid(pk_order);
						itemvo.setCfirstbillbid(vector.get(51).toString());
						itemvo.setCfirsttype("55A2");
						itemvo.setCinvbasid(pk_invbasdoc);
						itemvo.setCinventoryid(pk_invmandoc);
						icheadvo.setCinventoryid(pk_invmandoc);
						itemvo.setCprojectid(cprojectid);
						itemvo.setCrowno(Integer.toString((k+1)*10));
						itemvo.setCsourcebillhid(pk_order);
						itemvo.setCsourcebillbid(vector.get(51).toString());
						itemvo.setCsourcetype("55A2");
						itemvo.setDbizdate(dbilldate);
						itemvo.setFassertcardflag(UFBoolean.FALSE);
						itemvo.setFchecked(0);
						itemvo.setFlargess(UFBoolean.FALSE);
						itemvo.setIsok(UFBoolean.FALSE);
						itemvo.setNbarcodenum(new UFDouble(0));
						itemvo.setNoutnum(new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));
						itemvo.setNprice(new UFDouble(vector.get(26)==null?"0":vector.get(26).toString()));
						itemvo.setNmny(itemvo.getNoutnum().multiply(itemvo.getNprice()));
//						itemvo.setNquotentmny(new UFDouble(vector.get(24)==null?"0":vector.get(24).toString()));
//						itemvo.setNquotentprice(new UFDouble(vector.get(26)==null?"0":vector.get(26).toString()));
//						itemvo.setNsalemny(new UFDouble(vector.get(24)==null?"0":vector.get(24).toString()));
//						itemvo.setNsaleprice(new UFDouble(vector.get(24)==null?"0":vector.get(26).toString()));
						itemvo.setNshouldoutnum(new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));
//						itemvo.setNtaxmny(new UFDouble(vector.get(23)==null?"0":vector.get(23).toString()));
//						itemvo.setNtaxprice(new UFDouble(vector.get(22)==null?"0":vector.get(22).toString()));
						itemvo.setAttributeValue("processcost", new UFDouble(vector.get(24)==null?"0":vector.get(24).toString()));
						itemvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
						itemvo.setVbatchcode(vector.get(6)==null?"":vector.get(6).toString());
						itemvo.setVfirstbillcode(headvo.getVbillno());
						itemvo.setVfree1(vector.get(11)==null?null:vector.get(11).toString());
						itemvo.setVfree2(vector.get(13)==null?null:vector.get(13).toString());
						itemvo.setVfree3(vector.get(12)==null?null:vector.get(12).toString());
						itemvo.setVfree4(vector.get(14)==null?null:vector.get(14).toString());
						itemvo.setVsourcebillcode(headvo.getVbillno());
						//回写数量
						UFDouble updatenum =  new UFDouble(vector.get(29)==null?"0":vector.get(29).toString()).add(new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));
						updatemap.put(vector.get(51).toString(), updatenum);
						itemvos[k]=itemvo;
						k = k + 1;
					}
				}
				aggvo.setChildrenVO(itemvos);
				aggvos[0] = aggvo;
				GeneralBillVO[] res = imaterapi.insertMaterialOuts(aggvos);
				GeneralBillVO resvo = res[0];
				Boolean updateres = iorder.UpdateIssueExecNum(updatemap);
				
				MessageDialog.showHintDlg(mainpanel, "成功", "材料出库单"+resvo.getVBillCode()+"新增成功");
			}  catch (Exception e1) {
				MessageDialog.showErrorDlg(mainpanel, "错误", e1.getMessage());
				return;
			}
		}
		
		//取消按钮
		if(e.getSource() == getCancelBtn()){
			this.closeCancel();
		}
		
	}

}







