package u8c.bs.mmpac.bp;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.pub.BusinessException;
import u8c.pubitf.rule.IRule;
import u8c.vo.ExAggOrderMainVO;
import u8c.vo.OrderInVO;

/**
 * 数据校验
 * @author 
 *
 */
public class ValidateRule implements IRule<ExAggOrderMainVO>{

	private  IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	
	@Override
	public void process(ExAggOrderMainVO[] vos) throws BusinessException {
		for(int i = 0; i < vos.length; i++) {
			OrderInVO[] orderInVOs = (OrderInVO[]) vos[i].getChildrenVO();
			for (int j = 0; j < orderInVOs.length; j++) {
				getDefdoc("HJ（合金）",orderInVOs[j].getAlloy());
				getDefdoc("BZ（标准）",orderInVOs[j].getStandard());
				getMeasdoc(orderInVOs[j].getCastunitid());
			}
		}
	}
	//查询自定义档案
    public  void getDefdoc(String doclistcode,String docname) throws BusinessException {
    	if(docname == null) {
    		return ;
    	}
        String sql = "select pk_defdoc from bd_defdoc where pk_defdoclist = (select pk_defdoclist from bd_defdoclist where doclistcode = '"+doclistcode+"') and docname ='"+docname+"'";
        String pk_defdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_defdoc == null) {
        	throw new BusinessException("以下档案在U8cloud系统中根据公司或者账簿信息找不到，请检查！详细信息：1、档案类型 自定义档案，档案名称："+docname+"");
        }
    }
    
    //查询计量档案
    public  void getMeasdoc(String shortname) throws BusinessException {
    	if(shortname == null) {
    		return ;
    	}
        String sql = "select pk_measdoc from bd_measdoc where measname ='"+shortname+"'";
        String pk_measdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_measdoc == null) {
        	throw new BusinessException("以下档案在U8cloud系统中根据公司或者账簿信息找不到，请检查！详细信息：1、档案类型 计量档案，档案名称："+shortname+"");
        }
    }
}
